<?

include "htaccess.php";


if( $_POST["do_select"] )
  $username = $_POST["select_username"];
elseif( $_POST["username"] )
  $username = $_POST["username"];
else
  $username = $_GET["username"];

if( $username and ! ok_username( $username ) ) {
  err( "bad username" );
  $username = "";
}

function print_users_select() {
  $username = $GLOBALS["username"];
  $users = get_users();
  if( count( $users ) > 0 ) {
    sort( $users );
    echo "<SELECT NAME=\"select_username\">\n";
    echo "<OPTION VALUE=\"\">---</OPTION>\n";
    foreach( $users as $u ) {
      echo "<OPTION VALUE=\"$u\" ";
      if( $username == $u )
        echo "SELECTED";
      echo ">$u</OPTION>\n";
    }
    echo "</SELECT>\n";
  } else {
    echo "(no users)\n";
  }
}

function print_username() {
  echo $GLOBALS["username"];
}

function print_groups() {
  $username = $GLOBALS["username"];
  $groups = get_groups();
  if( count( $groups ) > 0 ) {
    $groupnames = array_keys( $groups );
    sort( $groupnames );
    foreach( $groupnames as $groupname ) {
      echo "<INPUT TYPE=CHECKBOX NAME=\"in_$groupname\" ";
      if( $username and in_array( $username, $groups[$groupname] ) )
        echo "CHECKED ";
      echo "/>&nbsp;<a href=\"group.php?group=$groupname\">$groupname</a>\n";
    }
  }
}

function print_submits() {
  if( $GLOBALS["username"] and 
      in_array( $GLOBALS["username"], get_users() ) ) {
    echo "<INPUT TYPE=SUBMIT NAME=do_save value=\"",
	get_phrase("save"), "\">";
    echo "<INPUT TYPE=SUBMIT NAME=do_delete value=\"",
	get_phrase("delete"), "\">";
  } else {
    echo "<INPUT TYPE=SUBMIT NAME=do_create value=\"",
	get_phrase("create"), "\">";
  }
}


function update_groups( $username ) {
  $groups = get_groups();
  foreach( $groups as $groupname => $users ) {
    if( in_array( $username, $users ) ) {
      if( ! $_POST["in_$groupname"] ) {
        unset( $users[array_search( $username, $users )] );
	$groups[$groupname] = $users;
      }
    } elseif( $_POST["in_$groupname"] ) {
	$users[] = $username;
	$groups[$groupname] = $users;
    }
  }
  write_groups( $groups );
}

function do_create() {
  $username = $GLOBALS["username"];
  $users = get_users();
  if( ! $username )
    return err("missing username");
  if( in_array( $username, $users ) )
    return err("username already exists");
  $password = $_POST["password"];
  if( ! $password )
    return err( "missing password" );
  if( ! ok_password( $password ) )
    return err( "bad password" );
  write_user( $username, $password );
  update_groups( $username );
  err("user created");
}

function do_save() {
  $username = $GLOBALS["username"];
  if( ! $username )
    return err("missing username");
  $password = $_POST["password"];
  if( $password ) {
    if( ! ok_password( $password ) )
      return err( "bad password" );
    write_user( $username, $password );
  }
  update_groups( $username );
  err("user updated");
}

function do_delete() {
  $username = $GLOBALS["username"];
  if( ! $username )
    return err("missing username");
  $users = get_users();
  if( ! in_array( $username, $users ) )
    return err("username does not exist");

  # remove user
  write_user( $username, false );

  # remove user from groups
  $groups = get_groups();
  foreach( $groups as $groupname => $users ) {
    if( in_array( $username, $users ) ) {
      unset( $users[array_search( $username, $users )] );
      $groups[$groupname] = $users;
    }
  }
  write_groups( $groups );

  err("user deleted");
}


if( $_POST["do_create"] )
  do_create();
elseif( $_POST["do_save"] )
  do_save();
elseif( $_POST["do_delete"] )
  do_delete();

?>
