<?

include "htaccess.php";

if( $_POST["do_select"] )
  $dir = $_POST["select_dir"];
elseif( $_POST["dir"] ) {
  $dir = $_POST["dir"];
} else
  $dir = $_GET["dir"];

if( $dir and ! ereg( "^/", $dir ) )
   $dir = "/$dir";

if( $dir and ! ok_dirname( $dir ) ) {
  err("bad directory");
  $dir = "";
}


function print_dirs_select() {
  $dir = $GLOBALS["dir"];
  $dirs = get_dirs();
  if( count( $dirs ) > 0 ) {
    echo "<SELECT NAME=\"select_dir\">\n<OPTION VALUE=\"\">---</OPTION>\n";
    foreach( $dirs as $dirname ) {
      echo "<OPTION VALUE=\"$dirname\"";
      if( $dir == $dirname )
	echo " SELECTED ";
      $dirname = ereg_replace( "^/", "", $dirname );
      echo ">$dirname</OPTION>\n";
    }
    echo "</SELECT>\n";
  } else {
    echo "(" . get_phrase("no directories") . ")\n";
  }
}

function print_dir() {
  echo ereg_replace( "^/", "", $GLOBALS["dir"] );
}

function print_dirgroup_select() {
  $dir = $GLOBALS["dir"];
  $group = get_dir_group($dir);
  $groups = get_groups();
  if( count( $groups ) > 0 ) {
    echo "<SELECT NAME=\"group\">\n<OPTION VALUE=\"\">---</OPTION>\n";
    foreach( $groups as $groupname => $users ) {
      echo "<OPTION VALUE=\"$groupname\"";
      if( $group == $groupname )
	echo " SELECTED ";
      echo ">$groupname</OPTION>\n";
    }
    echo "</SELECT>\n";
  } else {
    echo "(" . get_phrase("no groups") . ")\n";
  }
}

function print_submits() {
  $dir = $GLOBALS["dir"];
  $dirs = get_dirs();
  if( $dir and in_array( $dir, $dirs ) ) {
    echo "<INPUT TYPE=SUBMIT NAME=do_save value=\"",
	get_phrase("save"), "\" />";
  } else {
    echo "<INPUT TYPE=SUBMIT NAME=do_create value=\"",
	get_phrase("create"), "\" />";
  }
}

function do_save() {
  $group = $_POST["group"];
  if( $group and ! ok_groupname( $group ) )
    return err("bad group");
  $dir = $GLOBALS["dir"];
  $dirs = get_dirs();
  $basedir = $GLOBALS["basedir"];
  $fulldir = "$basedir$dir";
  if( ! file_exists( $fulldir ) ) {
    # recursive mkdir:
    $curfulldir = $basedir;
    foreach( explode("/", $dir) as $d ) {
      if( $d == "" ) continue;
      $curfulldir="$curfulldir/$d";
      if( ! is_dir($curfulldir) ) {
	mkdir( $curfulldir );
      }
    }
    $GLOBALS["dirs"] = array(); # reset
  }
  if( set_dir_group( $dir, $group ) )
    err("Directory group saved");
}


if( $_POST["do_create"] )
  do_save();
elseif( $_POST["do_save"] )
  do_save();

?>
