<?

include "htaccess.php";

if( $_POST["do_select"] )
  $group = $_POST["select_group"];
elseif( $_POST["group"] )
  $group = $_POST["group"];
else
  $group = $_GET["group"];

if( $group and ! ok_groupname( $group ) ) {
  err("bad groupname");
  $group = "";
}


function print_groups_select() {
  $group = $GLOBALS["group"];
  $groups = get_groups();
  if( count( $groups ) > 0 ) {
    echo "<SELECT NAME=\"select_group\">\n<OPTION VALUE=\"\">---</OPTION>\n";
    foreach( $groups as $groupname => $users ) {
      echo "<OPTION VALUE=\"$groupname\"";
      if( $group == $groupname )
	echo " SELECTED ";
      echo ">$groupname</OPTION>\n";
    }
    echo "</SELECT>\n";
  } else {
    echo "(" . get_phrase("no groups") . ")\n";
  }
}

function print_group() {
  echo $GLOBALS["group"];
}

function print_users() {
  $groups = get_groups();
  $group = $GLOBALS["group"];
  $members = $groups[$group];
  if( ! $members )
    $members = array();
  $users = get_users();
  if( count($users) <= $GLOBALS["view_members_only_limit"] )
    $view_users = $users;
  else
    $view_users = $members;
  foreach( $view_users as $u ) {
    $f = encode_fieldname("has_$u");
    echo "<INPUT TYPE=CHECKBOX NAME=\"$f\"";
    if( in_array( $u, $members ) )
      echo " CHECKED ";
    echo "/>&nbsp;<a href=\"user.php?username=$u\">$u</a>\n";
  }
}

function print_submits() {
  $group = $GLOBALS["group"];
  $groups = get_groups();
  if( $group and isset($groups[$group]) ) {
    echo "<INPUT TYPE=SUBMIT NAME=do_save value=\"",
	get_phrase("save"), "\" />";
    echo "<INPUT TYPE=SUBMIT NAME=do_delete value=\"",
	get_phrase("delete"), "\" />";
  } else {
    echo "<INPUT TYPE=SUBMIT NAME=do_create value=\"",
	get_phrase("create"), "\" />";
  }
}

function do_save() {
  $group = $GLOBALS["group"];
  $users = get_users();
  $members = Array();
  foreach( $users as $u ) {
    $f = encode_fieldname("has_$u");
    if( $_POST[$f] ) {
      $members[] = $u;
    } else {
    }
  }
  $groups = get_groups();
  $groups[$group] = $members;
  write_groups( $groups );
  err("groups saved");
}

function do_delete() {
  $group = $GLOBALS["group"];
  $groups = get_groups();
  unset($groups[$group]);
  write_groups( $groups );

  # free any dirs associated to this group
  $dirs = get_dirs();
  foreach( $dirs as $dir ) {
    $dirgrp = get_dir_group( $dir );
    if( $dirgrp == $group ) {
      echo "($dir $dirgrp=$group)<br/>";
      set_dir_group( $dir, false );
    }
  }

  err("group deleted");
}

if( ! $group )
     err("no group"); # no group; do nothing
elseif( $_POST["do_create"] )
  do_save();
elseif( $_POST["do_save"] )
  do_save();
elseif( $_POST["do_delete"] )
  do_delete();

?>
